"""Confighandler.py
Part of Mercury reader"""

from xml.sax.handler import ContentHandler
from user import User

class ConfigHandler(ContentHandler):
	server = ""
	port = ""
	channel = ""
	reconnect = ""
	nickname = ""
	realname = ""
	
	#Core properties
	inServer = False
	inPort = False
	inChannel = False
	inReconnect = False
	inNickname = False
	inRealname = False
	
	#users
	inUser = False
	UserType = ""
	UserGreet = ""
	
	BotRoot = ""
	UserList = []
	
	def startElement(self, name, attrs):
		if name == "server":
			#print "server found, setting..."
			self.inServer = True
		if name == "port":
			self.inPort = True
		if name == "channel":
			self.inChannel = True
		if name == "reconnect":
			self.inReconnect = True
		if name == "nickname":
			self.inNickname = True
		if name == "realname":
			self.inRealname = True
		if name == "user":
			self.inUser = True
			self.UserType = attrs.get("type", "")
			self.UserGreet = attrs.get("greet", "")
			if self.UserGreet == "":
				self.UserGreet = "nogreet"

		#print "Element name: ", name
		#print "Attrs: ", attrs

		
	def characters(self, characters):
		if self.inServer:
			self.server = characters
			#print "Server: ", self.server
			self.inServer = False
		if self.inPort:
			self.port = int(characters)
			#print "Port: ", self.port
			self.inPort = False
		if self.inChannel:
			self.channel = characters
			#print "Channel: ", self.channel
			self.inChannel = False
		if self.inReconnect:
			self.reconnect = characters
			#print "Reconnect: ", self.reconnect
			self.inReconnect = False
		if self.inNickname:
			self.nickname = characters
			#print "Nickname: ", self.nickname
			self.inNickname = False
		if self.inRealname:
			self.realname = characters
			#print "Realname: ", self.realname
			self.inRealname = False
		if self.inUser:
			"""Now this code is modified to work with Ozone"""
			#print "User: ", characters
			#print "Type: ", self.UserType
			#print "Greet: ", self.UserGreet
			if self.UserType == "BotRoot":
				self.BotRoot = characters
				#print "BotRoot ",self.BotRoot
			elif self.UserType == "Admin":
				usr = User(characters, "Admin", self.UserGreet)
				self.UserList.append(usr)
			elif self.UserType == "Op":
				usr = User(characters, "Op", self.UserGreet)
				self.UserList.append(usr)
			elif self.UserType == "General":
				usr = User(characters, "General", self.UserGreet)
				self.UserList.append(usr)
				#self.GeneralList[characters] = self.UserGreet
				#print self.GeneralList
				
			self.inUser = False
